Subject: Re: [PATCH v3 10/12] l2tp: Add L2TP ethernet pseudowire support

From: "Paul E. McKenney" <[email-masked]>
Date: Fri, 2 Apr 2010 08:24:02 -0700

On Wed, Mar 31, 2010 at 10:38:36AM -0700, Paul E. McKenney wrote:
> On Wed, Mar 31, 2010 at 10:35:29AM +0100, James Chapman wrote:
> > Stephen Hemminger wrote:
> > > On Tue, 30 Mar 2010 17:18:19 +0100
> > > James Chapman <[email-masked]> wrote:
> > > 
> > >> +struct l2tp_eth_net {
> > >> +	struct list_head l2tp_eth_dev_list;
> > >> +	rwlock_t l2tp_eth_lock;
> > >> +};
> > > 
> > > Reader/write locks are discouraged because they are slower than
> > > spin locks.  If you have lots of readers use RCU, if reading
> > > is infrequent just use a spin lock.
> > 
> > Ok. In doing the conversion of the rwlocks in l2tp_core.c, I'm finding
> > that some list access primitives don't have rcu equivalents, namely
> > list_is_last(), list_for_each_entry_safe(). Is this intentional? Should
> > I add the missing ones in a separate patch?
> 
> The list_is_last() is RCU-safe already, since the ->next pointer is
> only compared, never dereferenced.  I suggest adding a comment to its
> header stating that it is RCU-safe.
> 
> Feel free to create a list_for_each_entry_safe_rcu(), and I will be
> happy to review it.

Right.  When using RCU, list_for_each_entry_safe_rcu() is not needed,
because destruction of the element you removed doesn't happen until the
end of a subsequent grace period.  By which time you will be done with
your RCU read-side critical section.

So you can just use list_for_each_entry_rcu(), you do not need a new
list_for_each_entry_safe_rcu().

But you did have me going for a bit!!!  ;-)

							Thanx, Paul